package de.draegerit.lambda;

import de.draegerit.lambda.util.Person;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import org.junit.After;
import org.junit.Before;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class LambdaTestCase {

  private static Logger logger = LoggerFactory.getLogger("LambdaTestCase.class");

  private long beforeTimestamp = -1L;

  protected static List<String> names = new ArrayList<>();

  protected static List<Person> persons = new ArrayList<>();

  static {
    names = Arrays.asList(new String[] { 
                  "Stefan", "Udo", "Andrea", 
                  "Melanie", "Luca", "Elena", 
                  "Mia", "Hannah", "Florian", 
                  "Thomas", "Samuel", "Alexander",
                  "Daniel","Udo" });
    
    persons = Arrays.asList(new Person[] {
          new Person("Stefan", "Draeger"),
          new Person("Max", "Mustermann"), 
          new Person("Stefan", "Mustermann"), 
          new Person("Bill", "Gates")}); 
  }

  @Before
  public void setup() {
    beforeTimestamp = System.currentTimeMillis();
  }

  @After
  public void tearDown() {
    long afterTimestamp = System.currentTimeMillis();
    logger.info("Geschwindigkeit: " + (afterTimestamp - beforeTimestamp) + "ms.");
  }
}
