package de.draegerit.lambda;

import java.util.List;
import java.util.stream.Collectors;

import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class TestCollect extends LambdaTestCase {

  private static Logger logger = LoggerFactory.getLogger("TestCollect.class");

  @Test
  public void testCollectwithJava8() {
    List<String> filteredNames = names.stream().filter(n -> {
      return n.equalsIgnoreCase("Stefan") && n.length() > 5;
    }).collect(Collectors.toList());
    filteredNames.stream().forEach(name -> logger.info(name));
  }

  @Test
  public void testCollectwithJava8Join() {
    String filteredNames = names.stream().filter(n -> {
      return n.length() > 5;
    }).collect(Collectors.joining(","));
    logger.info(filteredNames);
  }

  @Test
  public void testCollectwithJavaJoin() {
    StringBuilder builder = new StringBuilder();
    for (int i = 0; i < names.size(); i++) {
      builder.append(names.get(i));
      if ((i + 1) < names.size()) {
        builder.append(",");
      }
    }
    logger.info(builder.toString());
  } 
  
}
