package de.draegerit.lambda;

import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertNull;
import static org.junit.Assert.assertTrue;

import java.util.Optional;

import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class TestFilter extends LambdaTestCase {

  private static Logger logger = LoggerFactory.getLogger("TestFilter.class");

  @Test
  public void filterForStringPositiv() {
    Optional<String> name = names.stream().filter(n -> "Stefan".equalsIgnoreCase(n)).findAny();
    assertTrue(name.isPresent());
    logger.info(name.get());
  }

  @Test
  public void filterForStringPositivMultiple() {
    Optional<String> name = names.stream().filter(n -> {
      if(n.equalsIgnoreCase("Stefan") && n.length()>5) {
        return true;
      }
      return false;
    }).findAny();
    assertTrue(name.isPresent());
    logger.info(name.get());
  }

  @Test
  public void filterForStringNegativNull() {
    String name = names.stream().filter(n -> "Robin".equalsIgnoreCase(n)).findAny().orElse(null);
    assertNull(name);
    logger.info(name);
  }

  @Test
  public void filterForStringNegativNotNull() {
    String name = names.stream().filter(n -> "Robin".equalsIgnoreCase(n)).findAny().orElse("Melanie");
    assertNotNull(name);
    logger.info(name);
  }

  @Test
  public void beforeJava8() {
    for (String name : names) {
      if (name.equalsIgnoreCase("Stefan")) {
        logger.info(name);
        break;
      }
    }
  }

}
