package de.draegerit.lambda;

import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

import de.draegerit.lambda.util.Person;

import java.util.ArrayList;
import java.util.List;
import java.util.Optional;

import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class TestFindAny extends LambdaTestCase {

  private static Logger logger = LoggerFactory.getLogger("TestFindAny.class");

  @Test
  public void testFindAnyWithJava8() {
    Optional<Person> optional = persons.stream().findAny();
    assertTrue(optional.isPresent());
    logger.info(optional.get().toString());
  }

  @Test
  public void testFindAnyWithJava8EmptyList() {
    List<Person> nullList = new ArrayList<>();
    Optional<Person> optional = nullList.stream().findAny();
    assertFalse(optional == null);
    logger.info("Der Wert ist NULL!");
  }
  
  @Test
  public void testFindAnyWithJava8orElse() {
    List<Person> nullList = new ArrayList<>();
    Person person = nullList.stream().findAny().orElse(new Person("Steve","Jobs"));
    assertTrue(person.getFirstname().equalsIgnoreCase("Steve"));
    logger.info(person.toString());
  }
}
