package de.draegerit.lambda;

import static org.junit.Assert.assertFalse;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class TestMap extends LambdaTestCase{

  private static Logger logger = LoggerFactory.getLogger("TestMap.class");
  
  @Test
  public void testMappingBeforeJava8() {
    logger.info("testMappingBeforeJava8()");
    List<Person> personen = new ArrayList<>();
    for(String name: names) {
      personen.add(new Person(name));
    }
    assertFalse(personen.isEmpty());
  }
  
  @Test
  public void testMappingWithJava8Map() {
    logger.info("testMappingWithJava8Map()");
    List<Person> personen = names.stream().map(name -> new Person(name)).collect(Collectors.toList());
    assertFalse(personen.isEmpty());
  }
  
  
  private class Person{
    
    private String name;

    public Person(String name) {
      super();
      this.name = name;
    }
    
  }
}
