package de.draegerit.lambda;

import static org.junit.Assert.assertTrue;

import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;
import java.util.Optional;

import org.junit.Test;

public class TestMin extends LambdaTestCase {

  private List<Integer> numbers = Arrays.asList(new Integer[] { 10, 6, 1, 0, 4, 5, 3, 15, 2 });

  private final Comparator<Integer> comparator = (num1, num2) -> Integer.compare(num1, num2);

  @Test
  public void testMinJava8() {
    Optional<Integer> minValue = numbers.stream().min(comparator);
    assertTrue(0 == minValue.get());
  }

  @Test
  public void testMaxJava8() {
    Optional<Integer> maxValue = numbers.stream().max(comparator);
    assertTrue(15 == maxValue.get());
  }

  @Test
  public void testMinJavaBefore8() {
    int index = numbers.indexOf(Collections.min(numbers));
    Integer number = numbers.get(index);
    assertTrue(0 == number);
  }
  
  @Test
  public void testMaxJavaBefore8() {
    int index = numbers.indexOf(Collections.max(numbers));
    Integer number = numbers.get(index);
    assertTrue(15 == number);
  }

}
